﻿
/*  ======================================================================================================================================================================
Global variable
====================================================================================================================================================================== */
var XMLReader = 0; 

citiesList = new Object(); 		// Create a list of city Object
var citiesMap = {};
var cityIndex = 0;

camerasList = new Object(); 	// Create a list of camera Object
var camerasMap = {};
var camIndex = 0;

segmentsList = new Object(); 	// Create a list of segment Object
var segmentsMap = {};
var segIndex = 0;

sectionsList = new Object(); 	// Create a list of segment Object
var sectionsIndex = 0;

var intersectionsMap = {};

cameraAlertsList = new Object(); // Create a list of camera alert Object
var cameraAlertsMap = {};
var alertCamIndex = 0;

var segAlertsList = new Object(); // Create a  list of segemnt alert Object
var segAlertsMap = {};
var alertSegIndex = 0;
var markerMap = {};
var markerIndexMap = {};

var g_prevUpdateDate=0;
var g_prevUpdateTime=0;

var g_sUpdateDate;
var g_sUpdateTime;
var g_sInputIndex;
var g_curSelectedCity = "Quebec";
var g_dataDirectory = "Quebec";
var g_curNetwork = "Alerte-511";
var g_rootFolder = "root/";
var g_serverID = "http://www.alerte511.com/";
/*  ======================================================================================================================================================================
Constructor Object
====================================================================================================================================================================== */

 //City constructor
function City(id, name, initZoom, maxZoom, lat, lon, enabled, validated,dataServerURL ,cameraList, segmentList, cameraFiles, segmentFiles, validatedCamFiles, validatedSegFiles) {
    this.id = id;
    this.cityName = name;
    this.initialZoom = initZoom;
    this.maximumZoom = maxZoom;
    this.initialLat = lat;
    this.initialLon = lon;
    this.enabled = enabled;
    this.validated = validated;
    this.dataServerURL = dataServerURL;
    this.cameraList = cameraList;
    this.segmentList = segmentList;
    this.autoCamFiles = cameraFiles;
    this.autoSegFiles = segmentFiles;
    this.validatedCamFiles = validatedCamFiles;
    this.validatedSegFiles = validatedSegFiles;
  
}
// Camera Contructor
function CameraType(index,id, lat, lon, urlVideo, route, surname, description, trafficDirection,nord,sud,est,ouest) {
    this.index = index;
    this.id = id;
    this.lat = lat;
    this.lon = lon;
    this.urlVideo = urlVideo;
    this.route = route;
    this.surname = surname;
    this.description = description;
    this.trafficDirection = trafficDirection;
    this.iconURL = 0;
    this.iconPinURL = 0;
    this.iconPressPinURL = 0;
    this.classID = 0;
    this.alertID = 0;
    this.rankID = 0;
    this.nord = nord;
    this.sud = sud;
    this.est = est;
    this.ouest = ouest;
}



//Segment Constructor
function Segment(id, route, description,  cameras, centralCoord, msg1, msg2) {
	
    this.id = id;
    this.route = route;
    this.description = description;
    this.cameras = cameras;
    this.centralCoord = centralCoord;
    this.msg1 = msg1;
    this.msg2 = msg2;

}

// Section Constructor
function Section(segID,lat1,lon1,lat2,lon2,links) {
    this.segID = segID;
	this.lat1 = lat1;
	this.lon1 = lon1;
 	this.lat2 = lat2;
	this.lon2 = lon2;
    this.links = links;
}
// Intersection Constructor
function Intersection(segID,dir,links) {
    this.segID = segID;
	this.dir = dir;
    this.links = links;
}

////Camera Alert Constructor
function Alert(segID, camID, date, time, direction, classID, alertID, rankID) {
    this.segID = segID;
    this.camID = camID;
    this.date = date;
    this.time = time;
    this.direction = direction;
    this.classID = classID;
    this.alertID = alertID;
    this.rankID = rankID;
	this.report=false;

}


/*  ======================================================================================================================================================================
Load alert file
====================================================================================================================================================================== */
function XMLDataRequest() {

	
    this.LoadCityOptions = function(_url, _curSelectedCity, _foo) {

        // All files has been load
		var dataString = "?path=" + g_dataDirectory + "/"+_url;
		var error = false;
		var urlExt = g_serverID+"phpservices/GetXMLFile.php";
		//console.log(urlExt+dataString);
		$.ajax({
			type: "POST",
			url: urlExt+dataString,
			dataType: "xml",
			async: false,
			cache: false,
            success: function(data) {

				//alert('LoadCityOptions');
				var xmlDoc;
                    xmlDoc = data;

                var cityTag = xmlDoc.getElementsByTagName("City");
                cityIndex = 0;
                for (var i = 0; i < cityTag.length; i++) {
                    //Get city attributes
                    var xmlAtt = cityTag[i].attributes;
                    var id = xmlAtt.getNamedItem("CityID").nodeValue;
                    var name = xmlAtt.getNamedItem("Name").nodeValue;
                    var lat = xmlAtt.getNamedItem("Latitude").nodeValue;
                    var lon = xmlAtt.getNamedItem("Longitude").nodeValue;
                    var initZoom = xmlAtt.getNamedItem("InitialZoom").nodeValue;
                    var maxZoom = xmlAtt.getNamedItem("MaximumZoom").nodeValue;
                    var sEnabled = xmlAtt.getNamedItem("Enabled").nodeValue;
                    var enabled = sEnabled == "true" ? true : false;

                    //Get validation parameters
                    var valTimestamp = parseFloat(cityTag[i].getElementsByTagName("ValidationTimestamp")[0].childNodes[0].nodeValue);
                    var valDelayMax = cityTag[i].getElementsByTagName("ValidationDelayMax")[0].childNodes[0].nodeValue;
                    var actualTimestamp = new Date().getTime();
                    var timeDiff = (actualTimestamp - valTimestamp) / 1000;
                    //alert(timeDiff);
                    var validated = false;
                    if (timeDiff <= valDelayMax)
                        validated = "true";

                    //Get camera list filename
                    var xmlDataServerURL = cityTag[i].getElementsByTagName("DataServerURL")[0].childNodes[0].nodeValue;
                    var xmlCamList = cityTag[i].getElementsByTagName("CameraList")[0].childNodes[0].nodeValue;
                    var xmlSegList = cityTag[i].getElementsByTagName("SegmentList")[0].childNodes[0].nodeValue;
                    var xmlCamValues = cityTag[i].getElementsByTagName("AutoCamFile");
                    var autoCamFiles = new Array();
                    for (var j = 0; j < xmlCamValues.length; j++) {
                        autoCamFiles[j] = xmlCamValues[j].childNodes[0].nodeValue;
                    }
                    var autoSegFiles = new Array();
                    var xmlSegValues = cityTag[i].getElementsByTagName("AutoSegFile");
                    for (var j = 0; j < xmlSegValues.length; j++) {
                        autoSegFiles[j] = xmlSegValues[j].childNodes[0].nodeValue;
                    }
                    var validatedSegFiles = new Array();
                    var xmlSegValValues = cityTag[i].getElementsByTagName("ValidatedSegFile");
                    for (var j = 0; j < xmlSegValValues.length; j++) {
                        validatedSegFiles[j] = xmlSegValValues[j].childNodes[0].nodeValue;
                    }
                    var validatedCamFiles = new Array();
                    var xmlCamValValues = cityTag[i].getElementsByTagName("ValidatedCamFile");
                    for (var j = 0; j < xmlCamValValues.length; j++) {
                        validatedCamFiles[j] = xmlCamValValues[j].childNodes[0].nodeValue;
                    }
                    citiesList[cityIndex] = new City(id, name, initZoom, maxZoom, lat, lon, enabled, validated, xmlDataServerURL, xmlCamList, xmlSegList, autoCamFiles, autoSegFiles, validatedCamFiles, validatedSegFiles);
                    citiesMap[id] = citiesList[cityIndex];
                    cityIndex++;

                }
                
                //alert("LoadCityOptions");
                //Run user function
               if(_foo!=null) _foo.call();
			   
            },
			error:function (xhr, status, error){
				//alert("Erreur :"+xhr.statusText);
			}
        });


        return true;
    };
    this.LoadCamList = function(_url, _curSelectedCity, _foo) {

		var dataString = "?path=" + g_dataDirectory + "/"+_url;
		var error = false;
		var urlExt = g_serverID+"phpservices/GetXMLFile.php";
		//console.log(urlExt+dataString);
		$.ajax({
			type: "POST",
			url: urlExt+dataString,
			dataType: "xml",
			async: false,
			cache: false,
            success: function(data) {

				//console.log("LoadCamList Success");
				var xmlDoc;

                    xmlDoc = data;

                camIndex = 0;
                var cameraTag = xmlDoc.getElementsByTagName("Camera");
                for (var i = 0; i < cameraTag.length; i++) {
                    var xmlAtt = cameraTag[i].attributes;
                    var id = xmlAtt.getNamedItem("CameraID").nodeValue;
					var nord = xmlAtt.getNamedItem("Nord").nodeValue;
					var sud = xmlAtt.getNamedItem("Sud").nodeValue;
					var est = xmlAtt.getNamedItem("Est").nodeValue;
					var ouest = xmlAtt.getNamedItem("Ouest").nodeValue;
                    var lat = xmlAtt.getNamedItem("Latitude").nodeValue;
                    var lon = xmlAtt.getNamedItem("Longitude").nodeValue;
                    var url = xmlAtt.getNamedItem("PreviewVideoUrl").nodeValue;
                    var roadName = xmlAtt.getNamedItem("AssociatedRoadName").nodeValue;
                    var surname = xmlAtt.getNamedItem("Surname").nodeValue;
                    var desc = xmlAtt.getNamedItem("Description").nodeValue;
                    var trafficDir = xmlAtt.getNamedItem("TrafficDirection").nodeValue;
                    var strTrafficDir = "";
                    switch (trafficDir) {
                        case '0':
                            strTrafficDir = 'Caméra au milieu de la route.';
                            break;
                        case '1':
                            strTrafficDir = 'Les véhicules dans la voie la plus rapprochée de la caméra circulent en direction nord';
                            break;
                        case '2':
                            strTrafficDir = 'Les véhicules dans la voie la plus rapprochée de la caméra circulent en direction sud';
                            break;
                        case '3':
                            strTrafficDir = 'Les véhicules dans la voie la plus rapprochée de la caméra circulent en direction est';
                            break;
                        case '4':
                            strTrafficDir = 'Les véhicules dans la voie la plus rapprochée de la caméra circulent en direction ouest';
                            break;
                    }
				
                    camerasList[camIndex] = new CameraType(camIndex,id, lat, lon, url, roadName, surname, desc, strTrafficDir,nord,sud,est,ouest);
                    camerasMap[id] = camerasList[camIndex];
                    SetIconURL(0, camerasList[camIndex]);
                    camIndex++;

                }
				//Get camera favorites from local storage
				GetUserFavorite();
				//console.log("LoadCamList Done");
                //Run user function
               if(_foo!=null) _foo.call();

            },
            cache: false // no cache please
        });

        return true;
    };
    this.LoadSegList = function(_url, _curSelectedCity, _foo) {

        //alert(_url);
        // All files has been load
		var dataString = "?path=" + g_dataDirectory + "/"+_url;
		var error = false;
		var urlExt = g_serverID+"phpservices/GetXMLFile.php";
		//console.log(urlExt+dataString);
		$.ajax({
			type: "POST",
			url: urlExt+dataString,
			dataType: "xml",
			async: false,
			cache: false,
            success: function(data) {
				//console.log("LoadSegList Success4");
              
                 var xmlDoc =data ;
                segIndex = 0;
               
               var segmentTag = xmlDoc.getElementsByTagName("Segment");
				//console.log(segmentTag.length);
				
                for (var i = 0; i < segmentTag.length; i++) {
                    var xmlAtt = segmentTag[i].attributes;
                    var segid = xmlAtt.getNamedItem("SegmentID").nodeValue;
                    var road = xmlAtt.getNamedItem("Road").nodeValue;
                    var desc = xmlAtt.getNamedItem("Description").nodeValue;
                    var lat = xmlAtt.getNamedItem("lat").nodeValue;
                    var lng = xmlAtt.getNamedItem("lon").nodeValue;
                    var msg1 = xmlAtt.getNamedItem("MessageID1").nodeValue;
                    var msg2 = xmlAtt.getNamedItem("MessageID2").nodeValue;
				    
				//Get sections list
                    var xmlSections = segmentTag[i].getElementsByTagName("Section");
 					var sLat2=0;
					var sLon2=0;
                    for (var j = 0; j < xmlSections.length; j++) {
                        var xmlSectionAtt = xmlSections[j].attributes;
                        var sLat1 = xmlSectionAtt.getNamedItem("lat").nodeValue;
                        var sLon1 = xmlSectionAtt.getNamedItem("lon").nodeValue;
						//alert(sLat1+" "+sLat2);
						sectionsList[sectionsIndex] = new Section(segid,sLat1,sLon1,sLat2,sLon2,0);
						sectionsIndex++;
						sLat2 = sLat1;
 						sLon2 = sLon1;
                    }
					//Get intersections list and attributes
                    var xmlIntersections = segmentTag[i].getElementsByTagName("Intersection");
                    for (var j = 0; j < xmlIntersections.length; j++) {
                        var xmlIntersectionAtt = xmlIntersections[j].attributes;
                        var dir = xmlIntersectionAtt.getNamedItem("dir").nodeValue;
                        var links = xmlIntersectionAtt.getNamedItem("links").nodeValue;
 						intersections = new Intersection(segid,dir,links);
						intersectionsMap[segid] = intersections ;
                
                    }
                    var xmlCameras = segmentTag[i].getElementsByTagName("Camera");
                    var cameras = new Array();
                    for (var j = 0; j < xmlCameras.length; j++) {
                        var xmlCameraAtt = xmlCameras[j].attributes;
                        var camid = xmlCameraAtt.getNamedItem("CameraID").nodeValue;
                        cameras.push(camid);
                    }
                    //console.log(segid);
					var coord = 0 ; //new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
                    segmentsList[segIndex] = new Segment(segid, road, desc,  cameras, coord, msg1, msg2);
                    segmentsMap[segid] = segmentsList[segIndex];
                    segIndex++;
                }
               // alert("LoadSegList Done");
                //Run user function
               if(_foo!=null) _foo.call();



            },
            cache: false // no cache please
        });

        return true;
    };
    this.LoadCamAlerts = function(_curSelectedCity,_checkUpdate, _success,_fail) {

        // All files has been load
        var cameraAlertQueue = {
            files: [],
            checkFinished: function() {
				//console.log("LoadCamAlerts");
	
                if (this.files.length > 0) {
                    for (var file in this.files) {

                        var data;
                            data = this.files[file].xml;


                        var bUpdated = false;
 
                        g_sUpdateDate = $(data).find('CameraAlert').attr('Date');
                        g_sUpdateTime = $(data).find('CameraAlert').attr('Time');
                        g_sInputIndex = $(data).find('CameraAlert').attr('Index');

                        // Clear current list
                        cameraAlertsList = {};
                        cameraAlertsMap = {};
                        alertCamIndex = 0;
                        //Read data from each item
                        $(data).find('Alert').each(function() {

                            var id = $(this).attr('CameraID');
                            var date = $(this).attr('Date');
                            var time = $(this).attr('Time');
                            var classID = Math.abs(parseInt($(this).attr('ClassID')));
                            var rankID = parseInt($(this).attr('Rank'));

                            // Add this alert to our list
                            cameraAlertsList[alertCamIndex] = new Alert(id, id, date, time, 0, classID, 0, rankID);
                            cameraAlertsMap[id] = cameraAlertsList[alertCamIndex];
                            // Increment alert index
                            alertCamIndex++;
                            //Set camera list values

                            SetIconURL(classID, camerasMap[id]);
                            camerasMap[id].classID = classID;
                            camerasMap[id].alertID = 0;
                            camerasMap[id].rankID = rankID;

                        });
                        //Run user  function
                        //console.log("XMLLoadCamAlerts");
                        if (_checkUpdate==true || g_prevUpdateDate == 0 || g_prevUpdateDate != g_sUpdateDate || g_prevUpdateTime != g_sUpdateTime) {
                            g_prevUpdateDate = g_sUpdateDate;
                            g_prevUpdateTime = g_sUpdateTime;
                            if(_success!=null) _success.call();
                        }
                        else
                           if(_fail!=null) _fail.call();

                    }

                }
            }
        };

        if (citiesMap[_curSelectedCity].validated == false) {
            // Create a queue of our alert file, so when each file has been read we will be able to parse each data file
            $(citiesMap[_curSelectedCity].autoCamFiles).each(function(index, cameraAlertFile) {
                //alert(cameraAlertFile);
				var dataString = "?path=" + g_dataDirectory + "/"+cameraAlertFile;
                //console.log(dataString);
				var error = false;
				var urlExt = g_serverID+"phpservices/GetXMLFile.php";
				//alert(urlExt+dataString);
				$.ajax({
					type: "POST",
					url: urlExt+dataString,
					dataType: "xml",
                    success: function(data) {
                        cameraAlertQueue.files.push({ url: cameraAlertFile, xml: data });
                        cameraAlertQueue.checkFinished();
                    },
                    cache: false // no cache please
                });
            });
        }
        else {
            // Create a queue of our alert file, so when each file has been read we will be able to parse each data file
            $(citiesMap[_curSelectedCity].validatedCamFiles).each(function(index, cameraAlertFile) {
 				var dataString = "?path=" + g_dataDirectory + "/"+cameraAlertFile;
				var error = false;
				var urlExt = g_serverID+"phpservices/GetXMLFile.php";
				//alert(urlExt+dataString);

				$.ajax({
 					type: "POST",
					url: urlExt+dataString,
					dataType: "xml",
                    success: function(data) {
                        cameraAlertQueue.files.push({ url: cameraAlertFile, xml: data });
                        cameraAlertQueue.checkFinished();
                    },
                    cache: false // no cache please
                });
            });
        }



        return true;
    };
    /*  ======================================================================================================================================================================
    Load each camera alert XML files for the current city
    ====================================================================================================================================================================== */
    this.LoadSegAlerts = function(_curSelectedCity, _success,_fail) {

        // All files has been load
        var segmentAlertQueue = {
            files: [],
            checkFinished: function() {
 			//alert("LoadSegAlerts");
               if (this.files.length > 0) {
                    for (var file in this.files) {

                        var data;

                         data = this.files[file].xml;

                        var bUpdated = false;
                        //                        g_sUpdateDate = $(data).find('SegmentAlert').attr('Date');
                        //                        g_sUpdateTime = $(data).find('SegmentAlert').attr('Time');
                        //                        g_sInputIndex = $(data).find('SegmentAlert').attr('Index');

                        // Clear current list
                        segAlertsList = {};
                        segAlertsMap = {};
                        alertSegIndex = 0;

                        $(data).find('Alert').each(function() {

                            var segmentID = $(this).attr('SegmentID');
                            var camID = $(this).attr('HotSpotCameraID');
                            var date = $(this).attr('Date');
                            var time = $(this).attr('Time');
                            var classID = Math.abs(parseInt($(this).attr('ClassID')));
                            var alertID = Math.abs(parseInt($(this).attr('AlertID')));
                            var direction = $(this).attr('Direction');
                            // alert(segmentID);
                            // Add this alert to our list
                            segAlertsList[alertSegIndex] = new Alert(segmentID, camID, date, time, direction, classID, alertID, 0);
                            segAlertsMap[segmentID] = segAlertsList[alertSegIndex];
							//MapCameraList(segAlertsList[alertSegIndex]);
                           // camerasMap[camID].rankID = alertSegIndex + 1;
                            //alert(camerasMap[camID].rankID + " " + camID);
                            // Increment alert index
                            alertSegIndex++;


                        });

                    }
                    //Run user  function
                     //alert("LoadSegAlerts");

                   if(_success!=null) _success.call();

                }
                else
                    if(_fail!=null) _fail.call();
            }

        };



        // Create a queue of our alert file, so when each file has been read we will be able to parse each data file
        if (citiesMap[_curSelectedCity].validated == false) {
            $(citiesMap[_curSelectedCity].autoSegFiles).each(function(index, segmentFile) {
				
				var dataString = "?path=" + g_dataDirectory + "/"+segmentFile;
				var error = false;
				var urlExt = g_serverID+"phpservices/GetXMLFile.php";
				//alert(urlExt+dataString);
				$.ajax({
					type: "POST",
					url: urlExt+dataString,
					dataType: "xml",
                    success: function(data) {

                        segmentAlertQueue.files.push({ url: segmentFile, xml: data });
                        segmentAlertQueue.checkFinished();
                    },
                    cache: false // no cache please
                });
            });
        }
        else {
            $(citiesMap[_curSelectedCity].validatedSegFiles).each(function(index, segmentFile) {
			
				var dataString = "?path=" + g_dataDirectory + "/"+segmentFile;
				var error = false;
				var urlExt = g_serverID+"phpservices/GetXMLFile.php";
  				//alert(urlExt+dataString);
               $.ajax({
					type: "POST",
					url: urlExt+dataString,
					dataType: "xml",
                   success: function(data) {

                        segmentAlertQueue.files.push({ url: segmentFile, xml: data });
                        segmentAlertQueue.checkFinished();
                    },
                    cache: false // no cache please
                });
            });
        }

	


        return true;
    };
    this.LoadAll = function(_curSelectedCity, _foo) {
        //console.log("LoadAll");
        g_curSelectedCity = getUserCity(); //_curSelectedCity;
        SetCityItem(g_curSelectedCity);
        // Load city option
        XMLReader.LoadCityOptions("CONFIG/CityList.xml",
                   _curSelectedCity,
                   function() {
                       //console.log("LoadCityOptions End");
                       //Load segment list
                       XMLReader.LoadCamList("CONFIG/CamList.xml",
                       _curSelectedCity,
                       //Load segment
                       function() {
                            //console.log("LoadCamList End");
                           XMLReader.LoadSegList("CONFIG/SegList.xml",
                            _curSelectedCity,
                           //Load alerts
                           function() {
                               //console.log("LoadSegList End");
                               //XMLReader.LoadCamAlerts(_curSelectedCity,
                               //Generate alert report
                                         // function() {
                                              // console.log("LoadCamAlerts End");
                                              //XMLReader.LoadSegAlerts(_curSelectedCity,
                                              //Generate alert report
                                                     // function() {
                                                         // console.log("LoadSegAlerts End");
                                                         if(_foo!=null) _foo.call();
                                                     // });


                                         // });
                           });
                       });
                   });

    };
    this.LoadRefresh = function(_checkUpdate,_success,_fail) {
        
        XMLReader.LoadCamAlerts(g_curSelectedCity,_checkUpdate,
                                function(){
                                    XMLReader.LoadSegAlerts(g_curSelectedCity, _success,_fail);
                                },_fail);

 
    };


}


function SetIconURL(_classID,_camera) {

    _camera.iconURL = "css/images/circleCamBlue.png";
    _camera.iconPinURL = "css/images/pinCamBlue.png";
    _camera.iconPressPinURL = "css/images/presspinCamBlue.png";
    //_camera.iconPinURL = "css/images/cam_marker_grey.png"; 
    //_camera.iconPressPinURL = "css/images/cam_marker_grey.png"; 

    // setIcon to alert color
    switch (_classID) {
            case 2:
                _camera.iconURL = "css/images/circleWarning.png"; //"css/images/circleCamYellow.png";
                //_camera.iconPinURL = "css/images/cam_marker_yellow.png";
                _camera.iconPinURL = "css/images/pinAlertWarning.png";; //"css/images/pinCamYellow.png";
                _camera.iconPressPinURL = "css/images/pinAlertWarning.png";
                break;
            case 3:
                _camera.iconURL = "css/images/circleWarning.png"; //"css/images/circleCamRed.png";
                //_camera.iconPinURL = "css/images/cam_marker_red.png";
                _camera.iconPinURL = "css/images/pinAlertWarning.png"; //"css/images/pinCamRed.png";
                _camera.iconPressPinURL = "css/images/pinAlertWarning.png";
                break;
            case 4:
                _camera.iconURL = "css/images/circleWarning.png";
                _camera.iconPinURL = "css/images/pinAlertWarning.png";
                //_camera.iconPinURL = "css/images/cam_marker_moving.png";
                _camera.iconPressPinURL = "css/images/pinAlertWarning.png";
                break;
            case 5:
                _camera.iconURL = "css/images/circleCamBlack.png";
                _camera.iconPinURL = "css/images/pinCamBlack.png";
                //_camera.iconPinURL = "css/images/cam_marker_censored.png";
                _camera.iconPressPinURL = "css/images/presspinCamBlack.png";
                break;
			default:
				_camera.iconURL = "css/images/circleCamBlue.png";
				_camera.iconPinURL = "css/images/pinCamBlue.png";
				//_camera.iconPinURL = "css/images/cam_marker_grey.png";
				_camera.iconPressPinURL = "css/images/presspinCamBlue.png";
                break;
	
               // _camera.iconPinURL = "css/images/cam_marker_censored.png"; 
               // _camera.iconPressPinURL = "css/images/cam_marker_censored.png"; 
        }
  
    //  alert(camId + " Class " + cameraAlertsMap[camId].classID)
    //  alert(iconImage);
 
}
function SetIconURLOld(_classID,_camera) {

    _camera.iconURL = "css/images/circleCamBlue.png";
    _camera.iconPinURL = "css/images/pinCamBlue.png";
    _camera.iconPressPinURL = "css/images/presspinCamBlue.png";
    //_camera.iconPinURL = "css/images/cam_marker_grey.png"; 
    //_camera.iconPressPinURL = "css/images/cam_marker_grey.png"; 

    // setIcon to alert color
    switch (_classID) {
            case 2:
                _camera.iconURL = "css/images/circleCamBlue.png"; //"css/images/circleCamYellow.png";
                //_camera.iconPinURL = "css/images/cam_marker_yellow.png";
                _camera.iconPinURL = "css/images/pinCamBlue.png";; //"css/images/pinCamYellow.png";
                _camera.iconPressPinURL = "css/images/presspinCamBlue.png";
                break;
            case 3:
                _camera.iconURL = "css/images/circleCamBlue.png"; //"css/images/circleCamRed.png";
                //_camera.iconPinURL = "css/images/cam_marker_red.png";
                _camera.iconPinURL = "css/images/pinCamBlue.png"; //"css/images/pinCamRed.png";
                _camera.iconPressPinURL = "css/images/presspinCamBlue.png";
                break;
            case 4:
                _camera.iconURL = "css/images/circleCamMove.png";
                _camera.iconPinURL = "css/images/pinCamMove.png";
                //_camera.iconPinURL = "css/images/cam_marker_moving.png";
                _camera.iconPressPinURL = "css/images/presspinCamMove.png";
                break;
            case 5:
                _camera.iconURL = "css/images/circleCamBlack.png";
                _camera.iconPinURL = "css/images/pinCamBlack.png";
                //_camera.iconPinURL = "css/images/cam_marker_censored.png";
                _camera.iconPressPinURL = "css/images/presspinCamBlack.png";
                break;
			default:
				_camera.iconURL = "css/images/circleCamBlue.png";
				_camera.iconPinURL = "css/images/pinCamBlue.png";
				//_camera.iconPinURL = "css/images/cam_marker_grey.png";
				_camera.iconPressPinURL = "css/images/presspinCamBlue.png";
                break;
	
               // _camera.iconPinURL = "css/images/cam_marker_censored.png"; 
               // _camera.iconPressPinURL = "css/images/cam_marker_censored.png"; 
        }
  
    //  alert(camId + " Class " + cameraAlertsMap[camId].classID)
    //  alert(iconImage);
 
}

function	MapCameraList(segmentAlert)
{
	for (var i=0;i<segIndex;i++ )
	{
		if(segmentsList[i].id==segmentAlert.segID)
		{
			//segmentAlert.cameraList=segmentsList[i].cameras;
			for(var j=0;j<segmentsList[i].cameras.length;j++)
			{
				var camID = segmentsList[i].cameras[j];
				segAlertsMap[camID] = segmentAlert;
			}
			break;
		}
	}
} 
    
    



    
    