/*  ======================================================================================================================================================================
Global variables 
====================================================================================================================================================================== */



var displayIndex = 0;
var sortedCameraList = [];
var g_map=0;
var displayTraffic = true;
var displayWorkzone = false;
var googleTrafficLayer = 0;
var bouncingQueue = new Array();
var winWidth;
var winHeight;
var g_newCenter;
var g_newZoom;
var displayMapMode = 'summary';
var firstLoopMap = true;
var previewMarker = 0;
var highlightedMarkerList = new Array();
var sections={};
var sectionIndex=0;
var circleList = new Array();
var g_mapDrag=false;
var g_NbrMarkers;

//////////////////////////////////////////////////////////////////


function InitMap() {
   
    //Set update time
//	SetUpdate(g_sUpdateDate,g_sUpdateTime);
    console.log("InitMap");
    
	
  
    //Display loader
   // DisplayLoader("Un moment svp!");
    
    //setTimeout(function() {
        g_newCenter = new google.maps.LatLng(citiesMap[g_curSelectedCity].initialLat, citiesMap[g_curSelectedCity].initialLon,false);
        //console.log(g_newCenter);
        g_newZoom = citiesMap[g_curSelectedCity].initialZoom;

        //Refresh map
		CreateGoogleMap();
		//CreateCloudMadeMap();
        
		AddMapEventHandler();
		
	
		//Create Zoom control
      //  CreateMapControl();
	
	
		//Create Navigation control
		//CreateNavigationControl('off');
		CreateCameraControl();
		
		//Create Navigation control
		//CreateRecordingControl();
		//Delete prevoious markers
		//DeleteCamerasMarkers();
		// Draw every camera marker on the map
		RefreshCamerasMarkers();
	
		
		//Draw traffic layer
		RefreshGoogleTraffic();
		
        //Hide loader and display vontrol button when loaded
		google.maps.event.addDomListener(g_map, 'tilesloaded', function() {
            //alert(firstLoopMap);
            if(firstLoopMap==true){
                firstLoopMap=false;
                 //Refresh all
                UpdateAll(true);
               
            }
               
		});        
		
		
		//DisplayAllSections(g_MaxSectionRadius);
       console.log("InitMap End");
   // }, 500);
   // alert("initMap");
}


function CreateGoogleMap() {

    //Clear previous map
    if (g_map != 0)
        $('#map_canvas').gmap('destroy');
    g_map = 0;

    // Set map options parse on XML city file
    var myOptions = {
        'center': g_newCenter,
        'zoom': parseInt(g_newZoom),
        'disableDefaultUI': true,
        'mapTypeId': google.maps.MapTypeId.ROADMAP
     };

   // alert(g_newCenter);
    // Create a new map with theses options
    $('#map_canvas').gmap(myOptions);
    g_map = $('#map_canvas').gmap('get', 'map');
	
  //  alert('CreateGoogleMap');
    //Set update time
	//SetUpdate(g_sUpdateDate,g_sUpdateTime);

}
function CreateOSMMap() {

    
    //Clear previous map
    if (g_map != 0)
        $('#map_canvas').gmap('destroy');
    g_map = 0;

    // Set map options parse on XML city file
    var myOptions = {
        'center': g_newCenter,
        'zoom': parseInt(g_newZoom),
        'disableDefaultUI': true,
        'mapTypeId': "OSM"
     };


    // Create a new map with theses options
    $('#map_canvas').gmap(myOptions);
    g_map = $('#map_canvas').gmap('get', 'map');
	
	
	//Define OSM map type pointing at the OpenStreetMap tile server
    g_map.mapTypes.set("OSM", new google.maps.ImageMapType({
        getTileUrl: function(coord, zoom) {
            return "http://tile.openstreetmap.org/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
        },
        tileSize: new google.maps.Size(256, 256),
        name: "OpenStreetMap",
        maxZoom: 18
    }));
			
    //Set update time
	//SetUpdate(g_sUpdateDate,g_sUpdateTime);


}
function CreateCloudMadeMap() {

    
    //Clear previous map
    if (map != 0)
        $('#map_canvas').gmap('destroy');
    map = 0;

    // Set map options parse on XML city file
    var myOptions = {
        'center': g_newCenter,
        'zoom': parseInt(g_newZoom),
        'disableDefaultUI': true,
        'mapTypeId': "CloudMade"
     };


    // Create a new map with theses options
    $('#map_canvas').gmap(myOptions);
    map = $('#map_canvas').gmap('get', 'map');
	
	//Draw traffic layer
	RefreshGoogleTraffic();
	
	//Define CloudMade map type pointing at the OpenStreetMap tile server
    g_map.mapTypes.set("CloudMade", new google.maps.ImageMapType({
        getTileUrl: function(coord, zoom) {
            return "http://b.tile.cloudmade.com/3eb6592d62c749248fad0d4abf007ac8/39481/256/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
        },
        tileSize: new google.maps.Size(256, 256),
        name: "CloudMade",
        maxZoom: 18
    }));
			
   

}
function CreateCameraControl(){

	
	var map = $('#map_canvas').gmap('get', 'map');
	//Create a div to hold the control.
	var camCtrlDiv = document.createElement('DIV');
	camCtrlDiv.style.marginLeft = '10px';
	camCtrlDiv.style.marginTop = '10px';
	camCtrlDiv.innerHTML = '<img src="css/images/securityCam.png" width="40px" height="40px"/>';
	//Bind envents
	google.maps.event.addDomListener(camCtrlDiv, 'click', function() {
		$( "#popupMenu1" ).panel( "open" );	
	});	
 	g_map.controls[google.maps.ControlPosition.LEFT_TOP].push(camCtrlDiv);

    var cityCtrlDiv = document.createElement('DIV');
	cityCtrlDiv.style.marginLeft = '10px';
	cityCtrlDiv.style.marginTop = '10px';
	cityCtrlDiv.innerHTML = '<img src="css/images/globe.png" width="40px" height="40px"/>';
	//Bind envents
	google.maps.event.addDomListener(cityCtrlDiv, 'click', function() {
		$( "#popupMenu3" ).panel( "open" );	
	});	
   
	g_map.controls[google.maps.ControlPosition.LEFT_TOP].push(cityCtrlDiv);
    
    var infoCtrlDiv = document.createElement('DIV');
	infoCtrlDiv.style.marginLeft = '10px';
	infoCtrlDiv.style.marginTop = '10px';
	infoCtrlDiv.innerHTML = '<img src="css/images/glyphicons_195_circle_info.png" width="40px" height="40px"/>';
	//Bind envents
	google.maps.event.addDomListener(infoCtrlDiv, 'click', function() {
		$( "#popupMenu2" ).panel( "open" );	
	});	
   
	g_map.controls[google.maps.ControlPosition.LEFT_TOP].push(infoCtrlDiv);
	
}
function CreateNavigationControl(_navMode){

	
	var map = $('#map_canvas').gmap('get', 'map');
	//Create a div to hold the control.
	var navCtrlDiv = document.createElement('DIV');
	navCtrlDiv.style.marginRight = '10px';
	navCtrlDiv.style.marginTop = '0px';
	var navigationDiv = document.createElement('DIV');
	
	g_map.controls[google.maps.ControlPosition.RIGHT_TOP].clear();  

	//Create navigation in control
	if(_navMode=='on'){
		navigationDiv.innerHTML = '<img src="css/images/glyphicons_185_screenshot.png" width="40px" height="40px"/>';
		navigationDiv.style.marginTop = '10px';
		navigationDiv.style.marginRight = '10px';
		navCtrlDiv.appendChild(navigationDiv);
		//Bind envents
		google.maps.event.addDomListener(navigationDiv, 'click', function() {
			//if(g_Version=='plus'){
				//Set on button
				CreateNavigationControl('off');
				//Stop Navigation
				StopNavigation();
				//Reset map position
				ResetMapPosition();
			//}
			//else
			//	DisplayVersionWarning();
		  });	
	}
	else{
		navigationDiv.innerHTML = '<img src="css/images/glyphicons_377_riflescope.png" width="40px" height="40px"/>';
		navigationDiv.style.marginTop = '10px';
		navigationDiv.style.marginRight = '10px';
		navCtrlDiv.appendChild(navigationDiv);
		//Bind envents
		google.maps.event.addDomListener(navigationDiv, 'click', function() {
			//if(g_Version=='plus'){
				//Set on button
				CreateNavigationControl('on');
				//Start Navigation
				StartNavigation();
			//}
			//else
			//	DisplayVersionWarning();
		  });	
	}
	g_map.controls[google.maps.ControlPosition.RIGHT_TOP].push(navCtrlDiv);
	
}

function CreateMapControl(){

	
	 //Add overlay control group
	//var divMapCtrl = document.getElementById('divCtrlWrapper');
	//map.controls[google.maps.ControlPosition.TOP_CENTER].push(divMapCtrl);  

	//ADd zoom control	
    var zoomCtrlDiv = document.createElement('DIV');
	zoomCtrlDiv.style.marginLeft = '10px';
	zoomCtrlDiv.style.marginTop = '10px';

	//Create zoom in control
    var zoomInDiv = document.createElement('DIV');
	zoomInDiv.innerHTML = '<img src="css/images/glyphicons_236_zoom_in.png" width="40px" height="40px"/>';
	zoomInDiv.style.marginTop = '10px';
	zoomCtrlDiv.appendChild(zoomInDiv);
	//Bind envents
	google.maps.event.addDomListener(zoomInDiv, 'click', function() {
		var g_newZoom = g_map.getZoom()+1;
		g_map.setZoom(g_newZoom);
	  });	
	  
	//Create zoom out control
    var zoomOutDiv = document.createElement('DIV');
	zoomOutDiv.innerHTML = '<img src="css/images/glyphicons_237_zoom_out.png" width="40px" height="40px"/>';
	zoomOutDiv.style.marginTop = '10px';
	zoomCtrlDiv.appendChild(zoomOutDiv);
	//Bind envents
	google.maps.event.addDomListener(zoomOutDiv, 'click', function() {
		var g_newZoom = g_map.getZoom()-1;
		g_map.setZoom(g_newZoom);
	  });	

	//Create Home control
    var zoomHomeDiv = document.createElement('DIV');
	zoomHomeDiv.innerHTML = '<img src="css/images/glyphicons_349_fullscreen.png" width="40px" height="40px"/>';
	zoomHomeDiv.style.marginTop = '10px';
	zoomCtrlDiv.appendChild(zoomHomeDiv);
	//Bind envents
	google.maps.event.addDomListener(zoomHomeDiv, 'click', function() {
		ResetMapPosition();
	  });		
    g_map.controls[google.maps.ControlPosition.LEFT_TOP].push(zoomCtrlDiv);  
	
}

function CreateRecordingControl(){

    var map = $('#map_canvas').gmap('get', 'map');
	
    var recordCtrlDiv = document.createElement('DIV');
	recordCtrlDiv.style.marginTop = '10px';
	recordCtrlDiv.style.marginRight = '10px';

	//Create recording  control
    var recordInDiv = document.createElement('DIV');
	recordInDiv.innerHTML = '<img src="css/images/glyphicons_300_microphone.png" width="40px" height="40px"/>';
	recordInDiv.style.marginTop = '10px';
	recordCtrlDiv.appendChild(recordInDiv);
	//Bind envents
	google.maps.event.addDomListener(recordInDiv, 'click', function() {
		var localDir = "com.alerte511";
	    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
			fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {

				//Play intro message
				AudioPlayIntro(dirEntry.fullPath+"/message");
				//Show recording page
				ShowRecordingPage();
				
			});
		});
	});	
	
	//Create CAMERA in control
    var cameraInDiv = document.createElement('DIV');
	cameraInDiv.innerHTML = '<img src="css/images/glyphicons_011_camera.png" width="40px" height="40px"/>';
	cameraInDiv.style.marginTop = '10px';
	recordCtrlDiv.appendChild(cameraInDiv);
	//Bind envents
	google.maps.event.addDomListener(cameraInDiv, 'click', function() {
		PicturePlayIntro();
		//capturePhoto();

	});	
	g_map.controls[google.maps.ControlPosition.RIGHT_TOP].push(recordCtrlDiv);
}
function AddMapEventHandler(){
	//Set moving map event
	google.maps.event.addListener(g_map, 'drag', function() {
    // 10 seconds after the center of the map has changed, pan back to the
    // marker.
		g_mapDrag=true;
	});
  	//Set moving map event
	google.maps.event.addListener(g_map, 'dragend', function() {
    // 10 seconds after the center of the map has changed, pan back to the
    // marker.
		g_mapDrag=true;
		setTimeout(function() {g_mapDrag=false;}, 10000);
	});
}
function RefreshMap(_Create) {

    
    if (_Create == true ) {
        //alert(firstLoopMap);

        //firstLoopMap = false;
        InitMap();
   
    }
    else {

		//setTimeout(function() { $('#map_canvas').gmap('refresh'); }, 1000);
		//alert('refresh Cam'); 
		//
		//Reste map position
		//ResetMapPosition();
        //Delete prevoious markers
        DeleteCamerasMarkers();
	     // Draw every camera marker on the map
        RefreshCamerasMarkers();
		
      //Draw traffic layer
        RefreshGoogleTraffic();
        
		console.log("RefreshMapCanvas ");
		RefreshMapCanvas();
		
    }
}
function RefreshMapCanvas(){
	$('#map_canvas').gmap('refresh'); 
	google.maps.event.trigger(g_map,'resize');
    //console.log("RefreshMapCanvas");
}

function RefreshGoogleTraffic() {
    if (displayTraffic == true) {
	
        if (googleTrafficLayer != 0)
            googleTrafficLayer.setMap(null);
        googleTrafficLayer = new google.maps.TrafficLayer();
        var map = $('#map_canvas').gmap('get', 'map');
        googleTrafficLayer.setMap(map);
		//Show legend
		HideLegend();
		CreateLegend();

		//$('.divLegend').css('display','block');
    }
    else {
        if (googleTrafficLayer != 0)
            googleTrafficLayer.setMap(null);
		HideLegend();

    }
}
function CreateLegend(){
    var map = $('#map_canvas').gmap('get', 'map');
	//Create a div to hold the control.
    var legendDiv = document.createElement('DIV');
    legendDiv.innerHTML = '<img src="css/images/gtrafficLegend.png"/>';
	legendDiv.style.border = 'solid 1px Black';
	legendDiv.style.marginRight = '10px';

    g_map.controls[google.maps.ControlPosition.RIGHT_BOTTOM].push(legendDiv);  

}

function HideLegend(){
  
	g_map.controls[google.maps.ControlPosition.RIGHT_BOTTOM].clear();  


}
function ResetMapPosition(){

    var g_newCenter = new google.maps.LatLng(citiesMap[g_curSelectedCity].initialLat, citiesMap[g_curSelectedCity].initialLon);
	var g_newZoom = citiesMap[g_curSelectedCity].initialZoom;
	var map = $('#map_canvas').gmap('get', 'map');
	g_map.setCenter(g_newCenter);
	g_map.setZoom(parseInt(g_newZoom));
	//alert(g_curSelectedCity);

}
function SetMapCenter(_curSelectedCity){

    var g_newCenter = new google.maps.LatLng(citiesMap[_curSelectedCity].initialLat, citiesMap[_curSelectedCity].initialLon);
	var g_newZoom = citiesMap[_curSelectedCity].initialZoom;
	var map = $('#map_canvas').gmap('get', 'map');
	g_map.setCenter(g_newCenter);
	g_map.setZoom(parseInt(g_newZoom));
	//alert(g_newZoom);

}

/*  ======================================================================================================================================================================
Draw every marker on the Google Map from the camera list
====================================================================================================================================================================== */
function DeleteCamerasMarkers() {
    
   // $('#map_canvas').gmap('clear', 'markers');
    for (var i=0;i<g_NbrMarkers;i++) {
		g_markerList[i].get(0).setMap(null);
	}
}
/*  ======================================================================================================================================================================
Draw every marker on the Google Map from the camera list
====================================================================================================================================================================== */
function RefreshCamerasMarkers() {

    // Draw a marker for each camera of my cameralist
    var index = 0;
    var zindex = 0;
    g_markerList = {};
	g_NbrMarkers=0;
	
    for (camera in camerasList) {
        var myLatLng = new google.maps.LatLng(camerasList[camera].lat, camerasList[camera].lon);
        var rank = camerasList[camera].rankID;
        var isFavorite = camerasList[camera].isFavorite;
        
        if (camerasList[camera].classID == 2 || camerasList[camera].classID == 3 || camerasList[camera].classID == 4)
            zindex = 2;
        else
            zindex = 1;
		
        if (displayMapMode == 'all' || 
			(displayMapMode == 'alerts' && zindex == 2) || 
			(displayMapMode == 'summary' && rank >0 ) ||
			(displayMapMode == 'favorite' && isFavorite == true) ){
            var name = camerasList[camera].id;
            var markerOption = {
                'position': myLatLng,
                'title': name,
                'visible': true,
                'zIndex': parseInt(zindex),
                'icon': camerasList[camera].iconPinURL
            };
			
			var marker = $('#map_canvas').gmap('addMarker', markerOption);
			g_markerList[g_NbrMarkers++]=marker;
			
			//Add events
            marker.click(function() {
 
                var camID = this.getTitle();
                //g_newCenter = $('#map_canvas').gmap('get', 'map').getCenter();
               // g_newZoom = $('#map_canvas').gmap('get', 'map').getZoom();
                //SelectMarker(camID,false);
              //Display video preview
				ShowImagePreview(camID);
				//Show preview page
				ShowPage('camera');

            });
        }
 
        //Incerement index
        index++;
    }
    //getAllMarker();
}

function getAllMarker() {
   
	markerMap = {};
    $('#map_canvas').gmap('find', 'markers', {},
     function(marker, isFound) {

         var camID = marker.getTitle();
         //alert(camID);
         markerMap[camID] = marker;
     });
    

 }
 
/*  ======================================================================================================================================================================
Draw every marker on the Google Map from the camera list
====================================================================================================================================================================== */
function animateCameraMarkers() {


    // For each camera markers
    for (camera in camerasList) {

        //Add alert to
        if (camerasList[camera].classID > 1 && camerasList[camera].classID < 5) {

            var marker = markerMap[camerasList[camera].id];
            // alert(marker.title + " " + isFound);
            marker.setAnimation(google.maps.Animation.BOUNCE);
            bouncingQueue.push(marker);
            setTimeout(function() {
                var stopMarker = bouncingQueue.pop();
                stopMarker.setAnimation(null);
            }, 2000);



        }
    }

}

function SelectMarker(_newCamID,_Bounce) {

	
 

    var myLatLng = new google.maps.LatLng(camerasMap[_newCamID].lat, camerasMap[_newCamID].lon);
 	var map = $('#map_canvas').gmap('get', 'map');
	
	var markerOption = {
        'position': myLatLng,
		'title': _newCamID,
        'visible': true,
        'zIndex': parseInt(10000),
        'icon': camerasMap[_newCamID].iconPressPinURL
    };
	//alert(_newCamID);
	//console.println(camerasMap[_newCamID].lat+ " "+camerasMap[_newCamID].lon);
	
   if (previewMarker != 0) {
        //alert(_newCamID);
        var marker = previewMarker.get(0);
        marker.setMap(null);
    }
	previewMarker = $('#map_canvas').gmap('addMarker', markerOption);
	if(_Bounce==true){
		g_map.setCenter(myLatLng);
		//previewMarker.get(0).setAnimation(google.maps.Animation.BOUNCE);
		//bouncingQueue.push(previewMarker);
		//setTimeout(function() {
		//	var stopMarker = bouncingQueue.pop();
		//	stopMarker.get(0).setAnimation(null);
		//}, 2000);
	}
	
	//alert("SelectMarker");
	previewMarker.click(function() {
        var camID = this.getTitle();
        //g_newCenter = $('#map_canvas').gmap('get', 'map').getCenter();
        //g_newZoom = $('#map_canvas').gmap('get', 'map').getZoom();

        ShowImagePreview(camID);
		//Show preview page
		ShowPage('camera');
		//DisplayCameraPreview(camID);
        //SelectMarker(camID,false);
     });
	 
	
 
}
function HighlightMarker(_newCamID) {
  
    var myLatLng = new google.maps.LatLng(camerasMap[_newCamID].lat, camerasMap[_newCamID].lon);
    var markerOption = {
        'position': myLatLng,
		'title': _newCamID,
        'visible': true,
        'zIndex': parseInt(10000),
        'icon': camerasMap[_newCamID].iconPressPinURL
    };

    marker = $('#map_canvas').gmap('addMarker', markerOption);
	highlightedMarkerList.push(marker.get(0));
 
}
function ClearHighlightMarkers() {

     for(var i=0;i<highlightedMarkerList.length;i++) {
        //alert(_newCamID);
        var marker = highlightedMarkerList[i];
        marker.setMap(null);
		//alert("ClearHighlightMarkers");
    }
	//alert("Clear");
}


var prevCenter;
function DisplayMap() {

    $('div#pnlMainPage').css('display', 'block');
   // $('div#pnlCameraPreviewPage').css('display', 'none');
    gmap('center', prevCenter);
    RefreshMapCanvas();
}


function RunSectionBuilder(_segID) {

	//Mouse position for debug
		map = $('#map_canvas').gmap('get', 'map');

		google.maps.event.addListener(g_map, 'click', function(event) {
						var lat =  event.latLng.lat();
						var lon = event.latLng.lng();
						SetSectionPoint(lat,lon);
						
						
					});
		google.maps.event.addListener(g_map, 'dblclick', function(event) {
						GetSectionLocation();
						
					});
		
}
function DisplaySection(_segID,_radius) {

	map = $('#map_canvas').gmap('get', 'map');
	
	DeleteCamerasMarkers();
	var circle;
	for(circle in circleList)
		circleList[circle].setMap(null);
	circleList = [];
	

  	for (section in sectionsList) {
       //Compute dist from each cam
        var segID = sectionsList[section].segID;
		var lat1 = parseFloat(sectionsList[section].lat1);
		var lon1 = parseFloat(sectionsList[section].lon1);
		var lat2 = parseFloat(sectionsList[section].lat2);
		var lon2 = parseFloat(sectionsList[section].lon2);
		var myLatLng = new google.maps.LatLng(lat1, lon1);
		if(segID==_segID){
			//var markerOption = {
			//	'position': myLatLng,
			//	'title': segID,
			//	'visible': true,
			//	'zIndex': parseInt(10000)
			//};
			//marker = $('#map_canvas').gmap('addMarker', markerOption);
			var circle_handle = new google.maps.Circle({
				'center': myLatLng,
				'radius': _radius,
				'zIndex':1000,
				'strokeColor': "#FF0000",
				'strokeOpacity': 0.5,
				'fillColor':'#FF0000',
				'fillOpacity':0.35,
				'map':map
			});
			circleList.push(circle_handle);
		}

   }


}

function SetSectionPoint(_lat,_lon){

	if(sectionIndex==0)
		sections = "<Section lat=\""+_lat+"\" lon=\""+_lon+"\"/>\n";
	else
		sections += "<Section lat=\""+_lat+"\" lon=\""+_lon+"\"/>\n";

	sectionIndex++;
	var myLatLng = new google.maps.LatLng(_lat,_lon);
	var markerOption = {
		'position': myLatLng,
		'title': "Section",
		'visible': true,
		'zIndex': parseInt(10000)
	};

	//var marker = $('#map_canvas').gmap('addMarker', markerOption);
	var map = $('#map_canvas').gmap('get', 'map');

	var circle = new google.maps.Circle({
			'center': myLatLng,
			'radius': 200,
			'zIndex':1000,
			'strokeColor': "#FF0000",
			'strokeOpacity': 0.5,
			'fillColor':'#FF0000',
			'fillOpacity':0.35,
			'map':g_map,
			'draggable':true
		});
	circleList.push(circle);
	google.maps.event.addListener(circle, 'rightclick', function(event) {
						GetSectionLocation();
					});
	google.maps.event.addListener(circle, 'dblclick', function(event) {
						circleList=[];
					});
	
}

function GetSectionLocation(){


	var	sections=[];
	for(var i=0;i<circleList.length;i++){
		myLatLng = circleList[i].getCenter();
		lat = myLatLng.lat();
		lon = myLatLng.lng();
		sections += "<Section lat=\""+lat+"\" lon=\""+lon+"\"/>\n";	
	}
	alert(sections);
	
}
function DisplayAllSections(_radius){
		map = $('#map_canvas').gmap('get', 'map');
	
	DeleteCamerasMarkers();
	var circle;
	for(circle in circleList)
		circleList[circle].setMap(null);
	circleList = [];
	

  	for (section in sectionsList) {
       //Compute dist from each cam
        var segID = sectionsList[section].segID;
		var lat1 = parseFloat(sectionsList[section].lat1);
		var lon1 = parseFloat(sectionsList[section].lon1);
		var lat2 = parseFloat(sectionsList[section].lat2);
		var lon2 = parseFloat(sectionsList[section].lon2);
		var myLatLng = new google.maps.LatLng(lat1, lon1);

		var circle_handle = new google.maps.Circle({
			'center': myLatLng,
			'radius': _radius,
			'zIndex':1000,
			'strokeColor': "#FF0000",
			'strokeOpacity': 0.5,
			'fillColor':'#FF0000',
			'fillOpacity':0.35,
			'map':map
		});
		circleList.push(circle_handle);

   }


}
	
function DisplayPin(_lat,_lon) {

		var myLatLng = new google.maps.LatLng(_lat, _lon);
		var markerOption = {
			'position': myLatLng,
			'title': 'pin',
			'visible': true,
			'zIndex': parseInt(10000),
			'icon':"css/images/presspinCamBlue.png"
		};
		marker = $('#map_canvas').gmap('addMarker', markerOption);

}

var prevLat=0;
var prevLon=0;
function RunProximitySearcher() {

	//Mouse position for debug
		map = $('#map_canvas').gmap('get', 'map');

		var date = new Date();
		g_timeBegin = Math.round(date.getTime()/1000);
		google.maps.event.addListener(g_map, 'click', function(event) {
						DeleteCamerasMarkers();
						var lat =  event.latLng.lat();
						var lon = event.latLng.lng();
						var segID = GetClosestSegment(lat,lon);
						GenerateLocalReport();

					});
		
}

function BindMapEvents() {

		//alert("BindMapEvents");
    //Map events

	
    $('#btnMapAll').click(function() {
        displayMapMode = 'all';
        SetToolbar();
 		if(g_displayMode=='map')
		//Refresh Map
			RefreshMap(false);
		else{
			//DisplayLoader("Un moment svp!");
			//Refresh list
			setTimeout(function(){RefreshList(true);},250);
		}
    });
    $('#btnMapAlerts').click(function() {
        displayMapMode = 'alerts';
        SetToolbar();
		if(g_displayMode=='map')
		//Refresh Map
			RefreshMap(false);
		else{
			//DisplayLoader("Un moment svp!");
			//Refresh list
			setTimeout(function(){RefreshList(true);},250);
		}
    }); 
    $('#btnMapSummary').click(function() {
        displayMapMode = 'summary';
        SetToolbar();
		if(g_displayMode=='map')
		//Refresh Map
			RefreshMap(false);
		else{
			//DisplayLoader("Un moment svp!");
			//Refresh list
			setTimeout(function(){RefreshList(true);},250);
		}
		
    }); 
	$('#btnMapFavorite').click(function() {
		//if(g_Version=="plus"){
			displayMapMode = 'favorite';
			SetToolbar();
			if(g_displayMode=='map')
			//Refresh Map
				RefreshMap(false);
			else{
				//DisplayLoader("Un moment svp!");
				//Refresh list
				setTimeout(function(){RefreshList(true);},250);
			}
		//}
		//else
		//	DisplayVersionWarning();
		
    }); 

    $('#btnSelectQue').click(function() {
		SetMapCenter("Quebec");
		SetCityItem("Quebec");
        setUserCity("Quebec");
        UpdateAll(true);
    });
	$('#btnSelectMtl').click(function() {
 		SetMapCenter("Montreal");
 		SetCityItem("Montreal");
        setUserCity("Montreal");
        UpdateAll(true);

    });
	$('#btnSelectTri').click(function() {
		SetMapCenter("TroisRivieres");
 		SetCityItem("TroisRivieres");
         setUserCity("TroisRivieres");
       UpdateAll(true);
 
    });
	$('#btnSelectGtn').click(function() {
  		SetMapCenter("Gatineau");
		SetCityItem("Gatineau");
        setUserCity("Gatineau");
        UpdateAll(true);

    });
}

function SetToolbar(){
	if(displayMapMode=='all')
		$('#btnMapAll').addClass('ui-btn-active');
	else
		$('#btnMapAll').removeClass('ui-btn-active');
		
	if(displayMapMode=='alerts')
		$('#btnMapAlerts').addClass('ui-btn-active');
	else
		$('#btnMapAlerts').removeClass('ui-btn-active');
		
	if(displayMapMode=='summary')
		$('#btnMapSummary').addClass('ui-btn-active');
	else
		$('#btnMapSummary').removeClass('ui-btn-active');
		
	
	if(displayMapMode=='favorite')
		$('#btnMapFavorite').addClass('ui-btn-active');
	else
		$('#btnMapFavorite').removeClass('ui-btn-active');
		
  //  if (displayWorkzone)
  //      $('#btnMapWorkzone').addClass('ui-btn-active');
  //  else
  //      $('#btnMapWorkzone').removeClass('ui-btn-active');

	if (displayTraffic)
        $('#btnMapGTraffic').addClass('ui-btn-active');
    else
        $('#btnMapGTraffic').removeClass('ui-btn-active');
}
function SetCityItem(_city){
	if(_city=='Quebec')
		$('#btnSelectQue').addClass('ui-btn-active');
	else
		$('#btnSelectQue').removeClass('ui-btn-active');
		
	if(_city=='Montreal')
		$('#btnSelectMtl').addClass('ui-btn-active');
	else
		$('#btnSelectMtl').removeClass('ui-btn-active');
		
	if(_city=='TroisRivieres')
		$('#btnSelectTri').addClass('ui-btn-active');
	else
		$('#btnSelectTri').removeClass('ui-btn-active');
		
	if(_city=='Gatineau')
		$('#btnSelectGtn').addClass('ui-btn-active');
	else
		$('#btnSelectGtn').removeClass('ui-btn-active');
    g_curSelectedCity = _city;
	
}
