// JavaScript Document

var userLocationIndex = 0;

var closeCameraList = new Array();
var closeSegmentList = new Array();
var prevUserLat = 0;
var prevUserLon = 0;
var g_userLat = 0;
var g_userLon = 0;
var camLat = 0;
var camLon = 0;
var bFirstLocation = true;
var myLocationMarker = 0;
var selectedCamId = 0;
var g_bNavigate = true;
var g_map = 0;
var watchID=0;
var g_bNavigation=false;
var g_successFuntion=0;
var demoLat;
var demoLon;
var g_timeBegin;
var g_timeEnd;
var demoMode = false;
var g_bulletinTimerHandle=0;
var g_currentSegID=0;
var g_prevSegID=0;
var g_resetHandle=0;
var g_MaxSectionRadius=300;
var g_closestCamID='none';
var g_noGPS=false;


function StartNavigation() {
	//$('#btnNavigation').addClass('ui-btn-active');

	var date = new Date();
	g_timeBegin = Math.round(date.getTime()/1000);
	
    g_map = $('#map_canvas').gmap('get', 'map');
	g_bLocalBulletinMode=true;
	
	//Play navigation intro message
	//PlayLocalBulletinIntro();
	//Start navigation loop
	bFirstLocation=true;
	g_closestCamID='none';
    startLoopNavigation(g_map);
    g_bNavigation = true;
	g_currentSegID=0;
	g_prevSegID=0;
	
	//RefreshBulletin();
}
function StopNavigation() {

	//Resete button
	//$('#btnNavigation').removeClass('ui-btn-active');
	//Stop audio if playing
	//StopAudioPlayer();

	//Stop navigation loop
    stopLoopNavigation();
    g_bNavigation = false;
	g_closestCamID='none';

	if(g_bulletinTimerHandle!=0)
		clearTimeout(g_bulletinTimerHandle);
	g_bulletinTimerHandle=0;
	g_bLocalBulletinMode=false;

}
function RefreshUserLocation() {

	if(g_bNavigation==false)
		return;
    g_map = $('#map_canvas').gmap('get', 'map');
	prevSegID=0;
    var lat = g_userLat; 
    var lon = g_userLon; 
    var position = { coords: { latitude: lat, longitude: lon } };
	
    updateUserLocation(position);
	

}
function RefreshBulletin(){

	
	//Get closest segment
	GetClosestSegment( g_userLat, g_userLon);
	//Get closest camera
	GetClosestCamera( g_userLat, g_userLon);
	//Generate local report
	GenerateLocalReport();

	//Refresh more frequently first time
	if(bFirstLocation == true)
		g_bulletinTimerHandle = setTimeout(function(){RefreshBulletin();},1000);
	else
		g_bulletinTimerHandle = setTimeout(function(){RefreshBulletin();},5000);
		


}
/*  ======================================================================================================================================================================
Update camera marker on Google map
1 : Camera marker is GREY
2 : Camera marker is GREEN
3 : Camera marker is RED
====================================================================================================================================================================== */
function GetUserLocation() {

	if(g_noGPS==true){
		g_userLat=g_userLon=0;
		return;
	}
    //Update user location
    //loopNavigation();
    if (navigator.geolocation) {
  
		var options = {
			  enableHighAccuracy: true,
			  timeout: 30000,
			  maximumAge: 0
		};
		watchID = navigator.geolocation.getCurrentPosition(getSingleUserLocation, callbackError, options);

    }
    // Browser doesn't support Geolocation
    else {
        g_userLat = g_newCenter.lat();
		g_userLon = g_newCenter.lng();
		//alert('Center '+g_userLat+' '+g_userLon);
    }
}
function startLoopNavigation(map) {

    g_bNavigate = true;
    g_map = map;
	
    DisplayLoader("Un moment svp!");
    //Update user location
    
    if (navigator.geolocation) {
        browserSupportFlag = true;
		prevSegID=0;
		if(demoMode==false){
			var options = {
				  enableHighAccuracy: true,
				  timeout: 30000,
				  maximumAge: 0
			};
			watchID = navigator.geolocation.watchPosition(updateUserLocation, callbackError, options);
		}
		
    }
    // Browser doesn't support Geolocation
    else {
        browserSupportFlag = false;
    }
	return browserSupportFlag;
}
function callbackError(error) {
    //Hide loader
    HideLoader();
    //PopAlert(g_bNavigate);
    if(g_bNavigate==true){

        if(error.code==1) //error.PERMISSION_DENIED:
                PopAlert("L'utilisateur n'a pas voulu donner sa position.");
        else
         if(error.code==2)//error.POSITION_UNAVAILABLE:
                PopAlert("Les coordonnées de l'utilisateur n'ont pas pu être trouvées. Veuillez vérifier si votre GPS est connecté.");
        else
        if(error.code==3)//error.TIMEOUT:
                PopAlert("La géolocalisation prend trop de temps. Veuillez vérifier si votre GPS est connecté.");
        else
            PopAlert("La géolocalisation a rencontré une erreur. Veuillez vérifier si votre GPS est connecté.");


        g_bNavigate = false;
        g_userLat = g_newCenter.lat();
        g_userLon = g_newCenter.lng();
        //Set on button
        CreateNavigationControl('off');
        //Stop Navigation
        StopNavigation();
        //Reset map position
        ResetMapPosition();
    }
}

function getSingleUserLocation(position) {
	if (position != 0) {
        //Center  map position
        g_userLat = position.coords.latitude;
        g_userLon = position.coords.longitude;
		//alert(g_userLat+' '+g_userLon);
	}
      
}

function updateUserLocation(position) {
    
    
    if (g_bNavigate ==true && g_map != 0 && position != 0) {
        //Center  map position
        var lat = position.coords.latitude;
        var lon = position.coords.longitude;
		var heading = position.coords.heading;

        //Center  map position
        var initialLocation = new google.maps.LatLng(lat, lon);
        

        //Set map center if first refresh
		if(demoMode==false){
			//Center map on car position
			if(g_mapDrag==false)
				g_map.setCenter(initialLocation);
				
			if (bFirstLocation == true) {
				//alert(position.coords.latitude + " " + position.coords.longitude);
				HideLoader();
                
				bFirstLocation = false;
				prevUserLat = lat;
				prevUserLon = lon;
				g_userLat = lat;
				g_userLon = lon;
				//alert("Lat: " + g_userLat + " Lon: " + g_userLon);
				//Create a marker
				SetCarIcon(initialLocation);
				g_map.setZoom(13);
				
				
			}
			else {
				//alert("Lat: " + g_userLat + " Lon: " + g_userLon);
				prevUserLat = g_userLat;
				prevUserLon = g_userLon;
				g_userLat = lat;
				g_userLon = lon;
			   //Get close camera
				//getClosestCamera(prevUserLat, prevUserLon, g_userLat, g_userLon);
				//Create a marker
				SetCarIcon(initialLocation);
				
				//alert("callbackSuccess");
				//if(g_successFuntion!=0)
				//{
				//	g_successFuntion.call();
				//	g_successFuntion=0;
				//}

			}
		}

    }
}



function stopLoopNavigation() {

	g_bNavigate = false;
	if (myLocationMarker != 0)
	{
        myLocationMarker.setMap(null);
		myLocationMarker=0;
	}	
	if(watchID!=0 )
		navigator.geolocation.clearWatch( watchID );
	prevSegID=0;
	prevDir=0;
	
   //PopAlert("stopLoopCloseCamera");
}



  
  
function SetCarIcon(_location)
{
//Create a marker
    if (myLocationMarker != 0)
	{
        myLocationMarker.setMap(null);
		myLocationMarker=0;
	}
      // alert(_location);
    var path = g_serverID+g_dataDirectory + "/NETWORKS/"+g_curNetwork+"/USERS/"+g_userProfil.avatar;
    myLocationMarker = new google.maps.Marker({
        'position': _location,
        'map': g_map,
       // 'icon': "http://maps.google.com/mapfiles/kml/pal4/icon23.png"
        'icon': path
    });
    myLocationMarker.setZIndex(1000);
	//alert("SetCarIcon");
}
function getDistanceFromLatLonInKm(lat1, lon1, lat2, lon2) {
         var R = 6371; // Radius of the earth in km
         var dLat = deg2rad(lat2 - lat1);  // deg2rad below
         var dLon = deg2rad(lon2 - lon1);
         var a =
             Math.sin(dLat / 2) * Math.sin(dLat / 2) +
             Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) *
             Math.sin(dLon / 2) * Math.sin(dLon / 2)
             ;
         var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
         var d = R * c; // Distance in km
         return d;
}
function getDistanceFromLatLon(lat1, lon1, lat2, lon2) {
    var xy1 = toMercator(lat1, lon1);
    var xy2 = toMercator(lat2, lon2);
 
    var ax = xy2[0] - xy1[0];
    var ay = xy2[1] - xy1[1];

    var norma = norm(ax,ay);
    return norma;
}
function getHeadingFromLatLon(lat1, lon1, lat2, lon2) {
    var dLon = (lon2 - lon1);
    var y = Math.sin(dLon) * Math.cos(lat2);
    var x = Math.cos(lat1) * Math.sin(lat2) - Math.sin(lat1) * Math.cos(lat2) * Math.cos(dLon);

    var brng = Math.atan2(y, x);

    return rad2deg(brng);
}
function getHeadingDifference(lat1, lon1, lat2, lon2, lat3, lon3) {
    var xy1 = toMercator(lat1, lon1);
    var xy2 = toMercator(lat2, lon2);
    var xy3 = toMercator(lat3, lon3);

    var ax = xy2[0] - xy1[0];
    var ay = xy2[1] - xy1[1];
    var bx = xy3[0] - xy1[0];
    var by = xy3[1] - xy1[1];
    var dotProduct = (ax * bx) + (ay * by);
    var norma = norm(ax,ay);
    var normb = norm(bx,by);
    var cosAngle = -1;
    if (normb != 0)
        cosAngle = dotProduct/normb;
	//alert(norma +" "+ normb+ " "+cosAngle + " "+getDistFromSection(lat1, lon1, lat2, lon2, lat3, lon3));

    return cosAngle;
}
function getDistFromSection(lat1, lon1, lat2, lon2, lat3, lon3) {
    var xy1 = toMercator(lat1, lon1);
    var xy2 = toMercator(lat2, lon2);
    var xy3 = toMercator(lat3, lon3);

    var ax = xy1[1] - xy2[1];
    var ay = xy2[0] - xy1[0];
    var bx = xy3[0] - xy1[0];
    var by = xy3[1] - xy1[1];
    var dotProduct = (ax * bx) + (ay * by);
	var norma = norm(ax,ay);
    var normb = norm(bx,by);
    var dist = -1;
    
    if (norma != 0)
        dist = Math.abs(dotProduct / (norma));
    return dist;
}



function norm(x,y) {
    return Math.sqrt(x*x+y*y);
}
function deg2rad(deg) {
    return deg * (Math.PI / 180);
}
function rad2deg(rad) {
    return 180 + (rad * 180) / Math.PI;
}
function toMercator(lat,lon) {
    var x = deg2rad(lon) * 20037508.34 / 180;
    var y = Math.log(Math.tan((90 + deg2rad(lat)) * Math.PI / 360)) / (Math.PI / 180);
    y = y * 20037508.34 / 180;
	
    return [x, y];
}

/*  ======================================================================================================================================================================
Update camera marker on Google map
1 : Camera marker is GREY
2 : Camera marker is GREEN
3 : Camera marker is RED
====================================================================================================================================================================== */
function GetClosestCameraHeading(_prevUserLat, _prevUserLon, _g_userLat, _g_userLon) {

    var headingDiffMin = 360;
    var lat = 0;
    var lon = 0;

    if (_prevUserLat == _g_userLat && _prevUserLon == _g_userLon)
        return;

    //Clear previous bouncing
    //if (selectedCamId != 0)
    //    markerMap[selectedCamId].setAnimation(null);

    for (camera in camerasList) {
       //Compute dist
        var camID = camerasList[camera].id;
        var distCam = getDistanceFromLatLonInKm(_g_userLat, _g_userLon, camerasList[camera].lat, camerasList[camera].lon);
        var headingCam = getHeadingFromLatLon(_g_userLat, _g_userLon, camerasList[camera].lat, camerasList[camera].lon);
        var userHeading = getHeadingFromLatLon(_prevUserLat, _prevUserLon, _g_userLat, _g_userLon);
        var headingDiff = Math.abs(userHeading - headingCam);

       // if (distCam < 1.5 && headingDiff<45 && headingDiff < headingDiffMin) {
        if (distCam > 0.5 && distCam < 2.5 && headingDiff < 45) {
            //alert(camID + " " + camerasList[camera].route);
            closeCameraList.push(camID);
            //headingDiffMin = headingDiff;
            //selectedCamId = camID;
            //lat = camerasList[camera].lat;
            //lon = camerasList[camera].lon;
         
       }

    }
    var newCamId = 0;
    if (selectedCamId != 0) {
        for (camera in closeCameraList) {
            var camID = closeCameraList.pop();
            if (camerasMap[camID].route == camerasMap[selectedCamId].route) {
                newCamId = camID;
                lat = camerasList[camera].lat;
                lon = camerasList[camera].lon;
            }
        }
    }
    else {
        newCamId = closeCameraList.pop();
        lat = camerasMap[newCamId].lat;
        lon = camerasMap[newCamId].lon;
    }
    if (newCamId != 0) {
        camLat = lat;
        camLon = lon;
        //closeCameraList.push(selectedCamId);
       // alert(newCamId + " " + camerasMap[newCamId].route);
        //displayImagePreview(newCamId);
        // markerMap[newCamId].setAnimation(google.maps.Animation.BOUNCE);
        DisplayCameraPreview(newCamId);
        SelectMarker(newCamId,false);
        selectedCamId=newCamId;
       
    }

    

}
function GetClosestCamera(_g_userLat, _g_userLon) {

	var dist_min=10;
	

    for (camera in camerasList) {
       //Compute dist
        var camID = camerasList[camera].id;
        var distCam = getDistanceFromLatLonInKm(_g_userLat, _g_userLon, camerasList[camera].lat, camerasList[camera].lon);
        if (distCam < dist_min) {
            g_closestCamID = camID;
			dist_min=distCam;
       }

    }
   

}

function GetClosestSegment( _g_userLat, _g_userLon) {


	var latMin,lonMin;
	var currentIndex2=-1;
	var currentSegID2=0;
	var minDist2=10; //min dist in km	
	var minDistThreshold=g_MaxSectionRadius/1000; //min dist in km
	for (section in sectionsList) {
       //Compute dist from each cam
        var segID = sectionsList[section].segID;
		var lat1 = parseFloat(sectionsList[section].lat1);
		var lon1 = parseFloat(sectionsList[section].lon1);
        var distFromBegin = getDistanceFromLatLonInKm(lat1, lon1, _g_userLat, _g_userLon);
		var links = sectionsList[section].links;
		
		if( distFromBegin< minDist2){
			minDist2 = distFromBegin;
			currentIndex2 = section;
			currentSegID2=segID;
			latMin=lat1;
			lonMin=lon1;

		}
    }
	if(demoMode==true)
		g_currentSegID="SEG001";
	else
	if(minDist2<=minDistThreshold ){
		g_currentSegID=currentSegID2;
		if(g_resetHandle!=0)
			clearTimeout(g_resetHandle);
		g_resetHandle=0;
	}
	else{
		//Reset current seg if out for more than 5 minutes.
		if(g_resetHandle==0)
			g_resetHandle = setTimeout(function(){g_currentSegID=0;},300000);
			
	}
		
	//console.println(currentSegID2+ " index2 "+currentIndex2+" Dist2 "+minDist2);
		
	//DisplaySection("SEG001",300);
	//DisplayPin(latMin,lonMin);
	//SetSectionPoint(latMin,lonMin);
	

}
function GenerateLocalReport() {
	
	//if(g_currentSegID==0)
	//	return;
	//alert(g_currentSegID);
	//Get possible links to user
	if(g_currentSegID!=0){
		var links = intersectionsMap[g_currentSegID].links;
		//Parse sementID form list
		for(var i=0;i<links.length;i+=7){
			var segID = links.substr(i,6);
			for (var j = 0; j < alertSegIndex; j++)
				if(segAlertsList[j].segID==segID)
				{
					segAlertsList[j].report=true;
					//alert("Report "+segID);
				}
			//alert(segID);
		}
	}
		
	var date = new Date()
	g_timeEnd = Math.round(date.getTime()/1000);
	var diffTime = Math.round(g_timeEnd-g_timeBegin);
	
	//console.cls();
	//console.println(diffTime + " sec " +g_prevSegID+" "+g_currentSegID);
	//alert(diffTime + " sec " +g_prevSegID+" "+g_currentSegID);

	if(g_currentSegID!=0 && (g_currentSegID!=g_prevSegID || (g_currentSegID==g_prevSegID && diffTime>=300))){
		g_timeBegin = g_timeEnd;
		//alert("Bulletin "+g_currentSegID);
		//If bulletin is busy playing wait
		if(PlayLocalBulletin(g_currentSegID)==false){
			g_currentSegID=g_prevSegID;

		}

	}
	
		
	g_prevSegID=g_currentSegID;
}
	

function SetUserLocation(_lat,_lon) {
	//alert(demoMode);
	if(demoMode==true){
		g_map = map;
	 
		if (bFirstLocation == true) {
			//alert(position.coords.latitude + " " + position.coords.longitude);
			bFirstLocation = false;
			prevUserLat = _lat;
			prevUserLon = _lon;
			g_userLat = _lat;
			g_userLon = _lon;

		}
		else {
			prevUserLat = g_userLat;
			prevUserLon = g_userLon;
			g_userLat = _lat;
			g_userLon = _lon;
		}
		var initialLocation = new google.maps.LatLng(_lat, _lon);
		SetCarIcon(initialLocation);
		
	}
	
  
}

var pointMarker=0;
function DisplayPoint(_lat,_lon) {

		if(pointMarker!=0)
			pointMarker.setMap(null);
			
		var myLatLng = new google.maps.LatLng(_lat, _lon);
		//pointMarker = $('#map_canvas').gmap('addMarker', markerOption);
		
		pointMarker = new google.maps.Marker({
				'position': myLatLng,
				'map': g_map,
				'zIndex': parseInt(10000),

			});
}
function BindNavigationEvents(){
	
	$('#radio-nav-everytime').bind("click", function() {
		g_navOnlyWhenAlerts=false;
    });	
	$('#radio-nav-onalerts').bind("click", function() {
		g_navOnlyWhenAlerts=true;
    });	
}	


